 package eu.clarin.cmdi.mdservice.action;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import eu.clarin.cmdi.mdservice.internal.Admin;
import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;

/**
 * Acts as a Struts 2 controller 
 * serves the requests regarding Components
 * it passes them further (Proxy) to the ComponentRegistry.
 *  
 * Nested Components are resolved during xsl-transformation. 
 * @author vronk 
 *
 */
public class CompRegistryProxyAction extends GenericProxyAction {

	private static final long serialVersionUID = 1L;
	
	private String proxy_key = "compregistry";
	private String compid;
	
	public String getCompid() {
		return compid;
	}

	public void setCompid(String compid) {
		this.compid = compid;
	}

	@Override 
	public String getFullFormat() {
		if (compid==null || compid.equals("")) {
			if (getActionkey().equals("elements")){
				return "terms2" + getFormat();	
			} else {
				return "complist2" + getFormat();
			}
		} else {
			return "comp2" + getFormat();
		}
	}
	
	@Override
	public String getProxyKey() {
		return proxy_key;
	}
	
	@Override
	/*
	public String getRequestKey() {
		String key="";
		if (getActionkey()!=null) {
			key += getActionkey() + "//-" ;
		}
		if (getCompid()!=null) {
			key += getCompid() + "//-" ;
		}
		 
		return key;
	}
*/
	 public String getRequestKey() {
		String key="";
		if (getActionkey()!=null) {
			key += getActionkey() + "//-" ;
		}else {
			key +="//-" ;
		}
		if (getCompid()!=null) {
			key += getCompid() + "//-" ;
		} else {
			key +="//-" ;
		}
		//if (getCollection()!=null) {
		key +="//-" ;
		
		//if (getSquery()!=null) {
		key +="//-" ;
		
		if (getStartItem()!=null) {
			key += getStartItem() + "//-";
		}
			else{
				key +="//-" ;
		}
		if (getMaximumItems()!=null) {
			key += getMaximumItems() + "//-";
		}
		else{
			key +="//-" ;
		}
		
		key += getRepository()  + "//-";
		key += getMaxdepth()  + "//-";
		
		if (getLang()!=null) {
			key += getLang() + "//-";
		}else{
			key +="//-" ;
		}
		
		 
		return key;
	}

		
	@SuppressWarnings("deprecation")	
	@Override
	public void prepare() throws Exception {		
		
		//Admin.notifyUser("CRPA.prepare");
		if (!getActionkey().equals("elements"))	{
			super.prepare();
		} else	{
//			Admin.notifyUser("CRPA.prepareSourceStream - elements");
			String xcid;
			InputStream _sourceStream;
			InputStream __sourceStream;
			InputStream _resultStream;
			
			_sourceStream = Cache.getCache().getFromCache(getRequestKey());
			if (_sourceStream == null) {
	//				Admin.notifyUser("CRPA.prepareSourceStream- profiles");
					setActionkey("profiles");
					setFormat("xmlresolved");
					__sourceStream = Cache.getCache().getFromCache(getRequestKey());
					if (__sourceStream == null) {
						__sourceStream = getSourceStream();
						xcid = Cache.getCache().putInCache(getRequestKey(),__sourceStream);			
						//Admin.notifyUser("CRPA-putting in cache: " + getRequestKey());	
						__sourceStream = Cache.getCache().getFromCache(getRequestKey());
					} else{
						//Admin.notifyUser("CRPA-reading from cache: " + getRequestKey());	
					}
			//		Admin.notifyUser("CCCRPA." + getTargetRequest());
				//	Admin.notifyUser("CCCRPA." + getFullFormat());
					MDTransformer transformer = new MDTransformer();
					transformer.setSrcFile(getTargetRequest());
					transformer.setParams(createTransformerParams());
					_sourceStream = transformer.transformXML(__sourceStream);//, getFullFormat(),null,null,null,null,null,null);
				//	Admin.notifyUser("CRPA.- elements");
					setActionkey("elements");
					setFormat("htmllist");
					xcid = Cache.getCache().putInCache(getRequestKey(),_sourceStream);			
			//		Admin.notifyUser("CRPA-putting in cache: " + getRequestKey());
					_sourceStream = Cache.getCache().getFromCache(getRequestKey());
			} /*else {
					Admin.notifyUser("CRPA-reading from cache: " + getRequestKey());
			}*/
				/*
			File file=new File(Cache.getCache().formPath(getRequestKey()));
			Admin.notifyUser("File-absolutePath " + file.getAbsolutePath());
			URL url = null;
			   try{
				   url = file.toURL();
				   Admin.notifyUser("URL-tostring " + url.toString());
				   }  catch (MalformedURLException me){
			  }
			 */
			
			if (getFormat().equals("xml")) {			
				_resultStream = _sourceStream;	
			}else {
				// set URL as srcFile (for MDTransformer to pass to xsl-scripts) 
				MDTransformer transformer = new MDTransformer();
				transformer.setSrcFile(getTargetRequest());
				transformer.setParams(MDTransformer.createParamsMap(getFullFormat()));
				_resultStream = transformer.transformXML(_sourceStream);//, getFullFormat());
					
			}
	
			Admin.notifyUser(getProxyKey() + " success:" + (_resultStream!=null));
			
			setSourceStream(_sourceStream);
			setResultStream(_resultStream);

			/*
			if (getFormat().equals("txt")) {
				File f=new File(Cache.getCache().formPath("terms_autocomplete.txt"));
			    OutputStream out=new FileOutputStream(f);
			    byte buf[]=new byte[1024];
			    int len;
			    while((len=getResultStream().read(buf))>0)
			    	out.write(buf,0,len);
			    out.close();
Admin.notifyUser("terms_autocomplete.txt");
			}
			*/
			
		}

	}


	/**
	 * uses base_url and (optionally) compid to form a url
	 * no compid => list all components/profiles
	 * @return the URL to component-registry
	 * @throws Exception 
	 */
	public URL getTargetRequest() throws IOException {
        // URL targetURL =new URL( base_url, compname + ".xml");
		URL targetURL = null;
		if (compid==null || compid.equals("")) {
			targetURL =new URL( getBaseURL(), getActionkey() );
		} else {
			targetURL =new URL( getBaseURL(), getActionkey() + "/clarin.eu:cr1:" + compid);
		}
//		Admin.notifyUser("CompReg.targetURL:" + targetURL);		
     //   URLConnection urlConnection = targetURL.openConnection();
//        urlConnection.setRequestProperty("Accept", "application/xml");                 
        return targetURL;
	}

	
}
