<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:my="myFunctions">

<!-- 
<purpose>generic functions for MDService2</purpose>
<history>
	<change on="2010-12-29" type="created" by="vr">extracted from cmd_commons.xsl</change>
</history>

-->
<xsl:include href="params.xsl"/>

<!-- <xsl:param name="mode" select="'html'" /> -->

<xsl:param name="dict_file" select="'dict.xml'" />
<xsl:variable name="dict" select="document($dict_file)" />
<xsl:variable name="terms_setup" select="document($terms_setup_uri)" />
<xsl:variable name="terms_flat" select="document($terms_flat_uri)" />


<!-- params for include-processing 
moved to params.xsl
	<xsl:param name="components_uri" select="'http://catalog.clarin.eu/ds/ComponentRegistry/rest/registry/components/'" />		
	<xsl:param name="prefix_replace" select="'file:///C:/Users/master/3lingua/clarin/CMDI/_repo2/metadata/toolkit/components'" />
-->

<!--  should be obsoleted by model2matrix.xsl
but it is not..
-->
<xsl:variable name="term_matrix" >
		
		<xsl:for-each select="//CMD_Element" >
					<xsl:variable name="context" select="my:context(.)" >
					</xsl:variable>
			<Term  elem="{@name}" datcat="{@ConceptLink}" profile="{ancestor::profileDescription[1]/name}" 
							parent="{ancestor::CMD_Component[1]/@name}"  context="{$context}" >
								<xsl:copy-of select="." />
			</Term>
		</xsl:for-each>
	
</xsl:variable>
<!-- 
<xsl:template match="Term" mode="matrix" >
		
		<xsl:for-each select=".//Term" >
			<xsl:variable name="context" select="my:context(.)" >
					</xsl:variable>
			<Term  elem="{@name}" datcat="{my:term2datcat(@name)}" profile="{ancestor::profileDescription[1]/name}" 
							parent="{ancestor::Term[1]/@name}"  context="{$context}" >
								<xsl:copy-of select="." />
			</Term>
		</xsl:for-each>
	
</xsl:template>

 -->
 
<xsl:function name="my:profilematrix" >
    <xsl:param name="term"/>
    
    <xsl:variable name="profile" select="my:profile($term,true())" />
    <Terms name="{$profile/name}"  id="{$profile/id}">
    	<xsl:for-each select="$profile//CMD_Component|$profile//CMD_Element" >
					<xsl:variable name="context" select="my:context(.)" />						
					
					<xsl:variable name="id"  >
							<xsl:choose>
								<xsl:when test="@ComponentId">
									<xsl:value-of select="@ComponentId" />
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="ancestor::CMD_Component[@ComponentId][1]/@ComponentId" /><xsl:text>#</xsl:text>
									<xsl:for-each select="ancestor::CMD_Component[not(descendant-or-self::CMD_Component[@ComponentId])]" >
									<xsl:value-of select="@name" />.</xsl:for-each><xsl:value-of select="@name" />
								</xsl:otherwise>
							</xsl:choose>							
					</xsl:variable>
			<Term  name="{@name}" datcat="{@ConceptLink}" id="{$id}" 
							parent="{ancestor::CMD_Component[1]/@name}" context="{$context}" 
							>
								<!--  <xsl:copy-of select="." /> -->
			</Term>
		</xsl:for-each>
	</Terms>
    
</xsl:function>

<xsl:function name="my:profile" >
    <xsl:param name="term"/>
    <xsl:param name="resolve" /> <!--  true|false-->
    
    <!-- <xsl:message>cmdprofiles_uri: <xsl:value-of select="$cmdprofiles_uri" /></xsl:message>  -->
    
    <xsl:variable name="profile" select="doc($cmdprofiles_uri)//profileDescription[name=$term]" />
    
    <xsl:choose>
      <xsl:when test="$resolve=true()">
      		<xsl:apply-templates select="$profile" mode="include" />
      </xsl:when>
      <xsl:otherwise>
      		<xsl:copy-of select="$profile" />
      </xsl:otherwise>
    </xsl:choose>
    
        
</xsl:function>

<!--
<xsl:function name="my:term2datcat">
    <xsl:param name="term"/>                              
    <xsl:value-of select="$term_matrix/*[@elem=$term]/@datcat" />                     			
</xsl:function>
-->

	<xsl:function name="my:dict">
     <xsl:param name="key"/>                              
     <xsl:value-of select="my:dict($key, $key)" />                     			
   </xsl:function>
   
	<xsl:function name="my:dict">
     <xsl:param name="key"/>                            
     <xsl:param name="fallback"/>      
     		<xsl:choose>
  			<xsl:when test="$dict/list/item[@key=$key]" >
  				<xsl:value-of select="$dict/list/item[@key=$key]" />
  			</xsl:when>  			
  			<xsl:when test="$dict/list/item[.=$key]" >
  				<xsl:value-of select="$dict/list/item[.=$key]/@key" />
  			</xsl:when>  			
  			<xsl:otherwise>
  			<xsl:value-of select="$fallback" />
  			</xsl:otherwise>
  		</xsl:choose>
   </xsl:function>
   		
	<xsl:function name="my:extractID" >		
		<xsl:param name="uri" />
		
		<xsl:choose>
			<xsl:when test="contains($uri,$isocat_base_uri)">
				<xsl:value-of select="substring-after($uri, $isocat_base_uri)" />
			</xsl:when>
			<xsl:when test="contains($uri,$components_id_prefix)">
			<!--   <xsl:value-of select="substring-after($uri,$components_id_prefix)" /> -->
				<xsl:value-of select="substring-after($uri, $components_id_prefix)" />
			</xsl:when>
			<xsl:otherwise><xsl:value-of select="$uri" /></xsl:otherwise>
		</xsl:choose>		
	</xsl:function>
	
	
	<xsl:function name="my:shortURL" >
		<xsl:param name="url" />
		<!--   <xsl:value-of select="replace($url, 'http://www.isocat.org/datcat/','isocat:')" /> -->
		 <xsl:variable name="matching_termset"  select="if($url!='') then $terms_setup/Termsets/Termset[@url_prefix][starts-with($url,@url_prefix)] else ()" />
		 <!-- <xsl:variable name="matchinge_termset"  select="if($url!='') then if ($terms_setup/Termsets/Termset[@url_prefix][starts-with($url,@url_prefix)]) then $terms_setup/Termsets/Termset[@url_prefix][starts-with($url,@url_prefix)][1] 
		 				else if $terms_setup/Termsets/Termset[@url][starts-with($url,@url)] then $terms_setup/Termsets/Termset[@url][starts-with($url,@url)][1] else ()" /> -->  
		 <xsl:message>shortURL: <xsl:value-of select="$matching_termset/@url_prefix" />:: <xsl:value-of select="$url" />
		</xsl:message>  		
		<xsl:value-of select="if ($matching_termset/@url_prefix and $matching_termset/@url_prefix!='' and $url!='') then replace($url, $matching_termset[1]/@url_prefix, concat(string-join($matching_termset/@id,','),':')) else $url" />		
	</xsl:function>	
	
	<!--  rewrite specific URLs (linking to target services) to redirect them locally (via MDService)
	should work for: dcif:dataCategory@pid, pcompone
	-->
	<xsl:function name="my:rewriteURL" >
		<xsl:param name="url" />	
		<xsl:choose>
				<xsl:when test="contains($url,$isocat_base_uri)">
						<xsl:value-of select="replace($url, $isocat_uri_match, $isocat_uri_replace)" />
				</xsl:when>	
				<xsl:otherwise><xsl:value-of select="concat($detail_complist_prefix, my:extractID($url))" /></xsl:otherwise>
			</xsl:choose>		
	</xsl:function>	
		
		
	<!-- shall be usable to form consistently all urls within xsl 
	started from:   
	{$base_dir}/values/htmllist/?q={@path} -->
	<xsl:function name="my:formURL" >
		<xsl:param name="action" />
		<xsl:param name="format" />
		<xsl:param name="q" />
		
		<xsl:choose>
			<xsl:when test="$action=''">
				<xsl:value-of select="concat($base_dir, '/?q=', $q, '&amp;repository=', $repository_name)" />
			</xsl:when>
			<xsl:when test="$q=''">
				<xsl:value-of select="concat($base_dir, '/',$action, '/?format=', $format)" />
			</xsl:when>			
			<xsl:otherwise>
				<xsl:value-of select="concat($base_dir, '/',$action, '/?format=', $format, '&amp;', $q, '&amp;repository=', $repository_name)" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:function>
	
		<!--  previously known as comppath -->
	<xsl:function name="my:context" >
		<xsl:param name="child" />
		<xsl:variable name="collect" >
				<xsl:for-each select="$child/ancestor::CMD_Component|$child/ancestor::Term" >
						<xsl:value-of select="@name" />.</xsl:for-each><xsl:value-of select="$child/@name" />
		</xsl:variable>
		<xsl:value-of select="$collect" />	
	</xsl:function>	

	<xsl:function name="my:encodePID" >
		<xsl:param name="pid" />				
		<xsl:value-of select="encode-for-uri(replace(replace($pid,'/','%2F'),'\.','%2E'))" />	
	</xsl:function>	
   
<!-- 
<xsl:function name="my:numberFormat">
<xsl:param name="unit" />
	<xsl:choose>
		<xsl:when test="$unit='count' or $unit='count-distinct'" ><xsl:value-of select="$format_count" /></xsl:when>
		<xsl:when test="$unit='kg'" ><xsl:value-of select="$format_kg" /></xsl:when>
		<xsl:when test="$unit='t'" ><xsl:value-of select="$format_t" /></xsl:when>
		<xsl:when test="$unit='m3'" ><xsl:value-of select="$format_m3" /></xsl:when>
		<xsl:when test="$unit='per' or $unit='percent'" ><xsl:value-of select="$format_per" /></xsl:when>
		<xsl:when test="$unit='sum'" ><xsl:value-of select="$format_kg" /></xsl:when>
		<xsl:otherwise><xsl:value-of select="$format_default" /></xsl:otherwise>		
	</xsl:choose>
</xsl:function>
-->

<xsl:function name="my:index2xpath">
<xsl:param name="p_ix" />

	<xsl:variable name="ix_string" select="replace($p_ix,'_',' ')" />

	<xsl:variable name="ix_resolved" >
		<xsl:choose>
				<xsl:when test="contains($ix_string,':')">
					<xsl:variable name="prefix" select="substring-before($ix_string,':')" />				
					<xsl:variable name="termset" select="$terms_setup/Termsets/Termset[@id=$prefix]" />				
					
					<xsl:message>index2xpath.matching_termset:<xsl:copy-of select="$termset"/>
									ix_string:<xsl:value-of select="$ix_string"/>
					</xsl:message>
					<xsl:choose>
					<!-- magic happening here  -->
						<xsl:when test="$termset[@type='dcr' or @type='rr']">
							<xsl:variable name="expanded_context" select="$terms_flat//context[@path=$ix_string]"></xsl:variable>
								<xsl:variable name="expanded_query" >
									<xsl:text>(</xsl:text>
									<xsl:for-each select="distinct-values($expanded_context//context[@elem]/@path)">
										<xsl:variable name="prefix" select="substring-before(.,':')" />
										<xsl:variable name="termset" select="$terms_setup/Termsets/Termset[@id=$prefix]" />									
										<xsl:value-of select="concat($termset/@name,'//',substring-after(.,':'))" />
										<xsl:if test="position()!=last()"><xsl:text>|</xsl:text></xsl:if>
									</xsl:for-each>
									<xsl:text>)</xsl:text>
								</xsl:variable>
								<xsl:message>expanded-context:<xsl:value-of select="$expanded_query" /></xsl:message>
							<xsl:value-of select="$expanded_query" />
						</xsl:when>
						<xsl:when test="not($termset/@name)"> 
							<!-- when no matching termset, simply  use the original prefix  -->
							<xsl:value-of select="concat($prefix,'//',substring-after($ix_string,':'))" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="concat($termset/@name,'//',substring-after($ix_string,':'))" />	
						</xsl:otherwise>
					</xsl:choose>
					 
				</xsl:when>
				<xsl:otherwise><xsl:value-of select="$ix_string" />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
	<xsl:value-of select="translate($ix_resolved, '.', '/')" ></xsl:value-of>	
</xsl:function>

<!--  revert from xpath to cmdIndex
	not inverted to my:index2xpath (yet): 
	only handles simple xpaths (not union expansions)
  -->
<xsl:function name="my:xpath2index">
<xsl:param name="p_xpath" />

	<xsl:variable name="ix_resolved" >
		<!-- get rid off leading slashes -->
		<xsl:variable name="stripped" select="if (starts-with($p_xpath,'//')) then substring-after($p_xpath, '//') else $p_xpath"  />
		<xsl:choose>
				<xsl:when test="contains($stripped,'//')">
					<xsl:variable name="prefix" select="substring-before($stripped,'//')" />				
					<xsl:variable name="termset" select="$terms_setup/Termsets/Termset[@name=$prefix]" />				
					
					<xsl:message>xpath2index.matching_termset:<xsl:copy-of select="$termset/@id"/>									
					</xsl:message>
					<xsl:choose>
						<!-- cannot really happen: 
							<xsl:when test="$termset[@type='dcr' or @type='rr']">
							-->
						<xsl:when test="not($termset/@id)"> 
							<!-- when no matching termset, simply  use the original prefix  -->
							<xsl:value-of select="concat($prefix,':',substring-after($stripped,'//'))" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="concat($termset/@id,':',substring-after($stripped,'//'))" />	
						</xsl:otherwise>
					</xsl:choose>					 
				</xsl:when>
				<xsl:otherwise><xsl:value-of select="$stripped" />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
	<xsl:value-of select="translate($ix_resolved, '/', '.')" ></xsl:value-of>	
</xsl:function>


</xsl:stylesheet>