<?xml version="1.0" encoding="UTF-8"?>

<!--     
    $Date: 2010-05-09 $ 
    
    created based on comp2view.xsl vronk

<sample>
	<componentDescription>
		<id>clarin.eu:cr1:c_1272022528362</id>
		<description>Type of data collection</description>
		<name>Datacollection</name>
		<registrationDate>04/26/2010 12:12:52 CEST</registrationDate>
		<creatorName>Folkert de Vriend</creatorName>
		−
		<ns2:href>
		http://catalog.clarin.eu/ds/ComponentRegistry/rest/registry/components/clarin.eu:cr1:c_1272022528362
		</ns2:href>
		<groupName>CLARIN-Nl</groupName>
	</componentDescription>
</sample>
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
    xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:dcr="http://www.isocat.org"
    xmlns:my="myFunctions" >
    <xsl:strip-space elements="*"/>
    <xsl:include href="cmd_commons.xsl"/>

    <xsl:output method="xml" encoding="UTF-8" indent="yes"/>

	<xsl:param name="title" 
		select="concat('Component view: ', if(/CMD_ComponentSpec/Header/Name/text()) then /CMD_ComponentSpec/Header/Name/text() else /CMD_ComponentSpec/CMD_Component[1]/@name)" />				
			
	    
    <!-- main -->
    <!-- <xsl:template match="/"> -->
    <xsl:template name="continue-root"> 
        
          <!-- Process the complete tree -->        	        
	      
				<xsl:choose>
	    	 	<xsl:when test="$format='complist2htmldetail'" >
			      <div id="complist">
			      		<table class="show">
			      			<caption>Profiles in Component Registry</caption>
			      			<thead>
			      				<tr><th>name id</th><th>date author</th><th>description</th></tr>
			      			</thead>
		    	 				<xsl:apply-templates select="/*/*" mode="detail" />
		    	 			</table>
  	  	 		</div>
		   	 	</xsl:when>		   	 	
	    	 	<xsl:when test="$format='complist2htmlselect'" >    	 					      
			      		<select id="profile-select" class="cmds-ui-elem-stretch">		
		    	 				<xsl:apply-templates select="/*/*" mode="select"/>		    	 				
		    				</select>	    	 				    		
	    	 	</xsl:when>
	    	 	<xsl:otherwise>
	    	 			<div id="complist">
			      		<ul>		
		    	 				<xsl:apply-templates select="/*/*" />
		    	 			</ul>
		    			</div>	 
	    	 	</xsl:otherwise>
    	 </xsl:choose>
			
    </xsl:template>
    
    <!-- generate actual HTML(?)-view -->
  <xsl:template match="/*/*">
		<li><span><a href="{my:rewriteURL(id)}" ><xsl:value-of select="name" /></a></span></li>			
	</xsl:template>

  <xsl:template match="/*/*" mode="detail">
  	<!--  concat($detail_complist_prefix, my:extractID(id)) -->
		<tr><td><b><a href="{my:rewriteURL(id)}" ><xsl:value-of select="name" /></a></b></td>
			<td><xsl:value-of select="substring(registrationDate,1,10)" /><br/>
			<xsl:value-of select="creatorName" />
			</td>
			<td><xsl:value-of select="description" /></td>
		</tr>			
	</xsl:template>
	
	<xsl:template match="/*/*" mode="select">
		<option value="{my:extractID(id)}" ><xsl:value-of select="name" /></option>			
	</xsl:template>

</xsl:stylesheet>