<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:my="myFunctions"
  	xmlns:dcif="http://www.isocat.org/ns/dcif"
 >
<!-- 
<purpose> generate a termMatrix for a datcat-profile (dcif-based = isocat: http://www.isocat.org/rest/profile/5)</purpose>
<strategy>map from rdf to Terms </strategy>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-10-10" type="created" by="vr"></change>
</history>
-->
<xsl:import href="cmd_commons.xsl"/>

<xsl:output method="xml" indent="yes" > </xsl:output>

<xsl:param name="title" select="'Datcat terms'"></xsl:param>

<xsl:template name="continue-root">
<xsl:message>count terms:<xsl:value-of select="count(/dcif:dataCategorySelection/dcif:dataCategory)" /></xsl:message>
	<xsl:apply-templates select="/dcif:dataCategorySelection" />
</xsl:template>

<xsl:template match="dcif:dataCategorySelection" >
	<Termset id="isocat{if($lang!=$default_lang) then $lang else ''}" label="{concat(@name, ' [', $lang ,']')}" >		
		<xsl:apply-templates select="dcif:dataCategory" />		
	</Termset>
</xsl:template>

<!-- <Term elem="TextCorpusProfile" datcat="" corresponding_component="" parent="" context=".TextCorpusProfile" 
name="TextCorpusProfile" count="8" count_text="199" count_distinct_text="87" path="TextCorpusProfile"/>
 -->
 
 <!--  handling compressed dcif-format -->
<xsl:template match="dcif:dataCategory[@name]" >
	<Term type="datcat" name="{@name}" datcat="{@pid}" id="{@identifier}">		
		<xsl:for-each select="@*" >
			<xsl:element name="{name()}" ><xsl:value-of select="." /></xsl:element>			
		</xsl:for-each>
	</Term>
</xsl:template>

 <!--  handling full dcif-format -->
<xsl:template match="dcif:dataCategory" >
	<xsl:variable name="n" >
		<xsl:choose>
			<xsl:when test=".//dcif:name[@xml:lang=$lang]">
				<xsl:value-of select=".//dcif:name[@xml:lang=$lang]" />
			</xsl:when>
			<xsl:when test=".//dcif:name[@xml:lang=$default_lang]">
				<xsl:value-of select=".//dcif:name[@xml:lang=$default_lang]" />
			</xsl:when>
			<xsl:when test=".//dcif:name">
				<xsl:value-of select=".//dcif:name" />
			</xsl:when>
			<xsl:when test=".//dcif:dataElementName">
				<xsl:value-of select=".//dcif:dataElementName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select=".//dcif:identifier" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	
	<!--  <xsl:variable name="datcat" select="my:shortURL(@pid)" />  -->
				
	<Term type="datcat" name="{$n}" datcat="{@pid}" id="{.//dcif:identifier}">
		<xsl:copy-of select="dcif:administrationRecord/*" />
		<xsl:choose>
		<xsl:when test=".//dcif:languageSection[language=$lang]" >
			<xsl:for-each select=".//dcif:languageSection[language=$lang]//*[@xml:lang=$lang]" >			
					<xsl:element name="{name()}" ><xsl:value-of select="." /></xsl:element>			
			</xsl:for-each>			
		</xsl:when>
		<xsl:otherwise>
			<xsl:for-each select=".//dcif:languageSection[1]//*[exists(text()) and text()!='']" >			
					<xsl:element name="{name()}" ><xsl:value-of select="." /></xsl:element>			
			</xsl:for-each>
		</xsl:otherwise>
		</xsl:choose>
						
		<!--   probably need to add conceptual domain! -->
	</Term>
</xsl:template>

</xsl:stylesheet>
