﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:dcif="http://www.isocat.org/ns/dcif"   
	xmlns:xml="http://www.w3.org/XML/1998/namespace"
	 xmlns:my="myFunctions"
>
<!-- 
<purpose> generate a reduced html-view of a dcif-info</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-03-26" type="created" by="vr">from model2htmlsnippet.xsl</change>	
</history>
-->

<xsl:output method="xml" />

<xsl:include href="cmd_commons.xsl"/>

<!-- 
<xsl:param name="format" />
<xsl:param name="lang" select="'en'" /> 

<xsl:param name="mode" select="'div'" />
<xsl:param name="base_uri" select="'http://www.isocat.org/datcat/'" />
<xsl:param name="detail_uri_prefix"  select="'isocat/htmldiv'"/>
-->

<xsl:param name="title" >
	<xsl:choose>
		<xsl:when test="count(/dcif:dataCategorySelection/dcif:dataCategory) &gt; 1" >
			<xsl:text>isocatDCSelection |</xsl:text>			
			<xsl:value-of select="count(/dcif:dataCategorySelection/dcif:dataCategory)" /><xsl:text>| (</xsl:text>			 
			<xsl:value-of select="concat(my:extractID(//dcif:dataCategory[1]/@pid), //dcif:identifier[1])" /><xsl:text>)</xsl:text>			
		</xsl:when>
		<xsl:otherwise>
		<xsl:text>isocatDC: </xsl:text><xsl:value-of select="concat(my:extractID(//dcif:dataCategory[1]/@pid), //dcif:identifier[1])" /> 
		</xsl:otherwise>		
	</xsl:choose>
	
</xsl:param>



<xsl:template name="continue-root" >
	<!-- <h1><xsl:value-of select="$title"/></h1> -->
<xsl:message>count DCs:<xsl:value-of select="count(/dcif:dataCategorySelection/dcif:dataCategory)" /></xsl:message>
	<xsl:choose>
		<xsl:when test="count(/dcif:dataCategorySelection/dcif:dataCategory) &gt; 1" >
			<xsl:choose>
				<xsl:when test="contains($format,'htmllist')">
					<xsl:apply-templates select="/dcif:dataCategorySelection" mode="list" />
				</xsl:when>
				<xsl:otherwise>
						<xsl:apply-templates select="/dcif:dataCategorySelection"/> 
				</xsl:otherwise>		
			</xsl:choose>				
		</xsl:when>
		<xsl:otherwise>
				<xsl:apply-templates select="/dcif:dataCategorySelection/dcif:dataCategory"/> 
		</xsl:otherwise>		
	</xsl:choose>
	

	
	
</xsl:template>	

<xsl:template match="dcif:dataCategorySelection" >
	<div>
	<h3>DCSelection: <xsl:apply-templates select="@name" /></h3>
		<div class="header">
		|<xsl:value-of select="count(/dcif:dataCategorySelection/dcif:dataCategory)" />|
			<xsl:value-of select="dcif:globalInformation" />
		</div>
			
		<table>
			<tr>
				<th>PID</th>
				<th>identifier</th>
				<th>name</th>
				<th>definition</th>
				<th>type</th>
				<th>owner</th>		
			</tr>	
		<xsl:apply-templates select="dcif:dataCategory" mode="table" />
		</table>					
	</div>	
	
</xsl:template>	

<xsl:template match="dcif:dataCategory" mode="table">
	<tr>
		<td><xsl:value-of select="my:extractID(@pid)" /></td>
		<td><xsl:value-of select="@identifier" /></td>
		<td><xsl:value-of select="@name" /></td>
		<td><xsl:value-of select="@definition" /></td>
		<td><xsl:value-of select="@type" /></td>
		<td><xsl:value-of select="@owner" /></td>		
	</tr>
</xsl:template>	

<xsl:template match="dcif:dataCategorySelection"  mode="list">
	<div>
	<h3>DCSelection: <xsl:apply-templates select="@name" /></h3>
		<div class="header">
		|<xsl:value-of select="count(/dcif:dataCategorySelection/dcif:dataCategory)" />|
			<xsl:value-of select="dcif:globalInformation" />
		</div>
			
		<ul>	
			<xsl:apply-templates select="dcif:dataCategory" mode="list" />
		</ul>					
	</div>	
	
</xsl:template>	


<xsl:template match="dcif:dataCategory" mode="list">
		<li><div class="cmds-elem-plus">		
			<span><a href="{my:rewriteURL(@pid)}" >
						<xsl:value-of select="@name" /></a></span>
						<div class="detail">
							<xsl:value-of select="@definition" /><br/>
							<xsl:value-of select="@type" />,<xsl:value-of select="@owner" />
						</div>
			</div>
		</li>
</xsl:template>	

<xsl:template match="dcif:dataCategory" >

	<div>
	<h4><xsl:value-of select="concat(my:extractID(@pid), ': ', .//dcif:identifier)" /> 
	</h4>
		<xsl:apply-templates select=".//dcif:creationDate | .//dcif:profile | .//dcif:definition[@xml:lang=$lang]
			" />					
	</div>	
	
</xsl:template>	
	
	
<xsl:template match="*" >
	<!-- <xsl:param name="lv" select="1" />-->
	<!--<xsl:variable name="lv" select="count(ancestor::d)" /> -->
	<xsl:if test="string-length(.//text()) &gt; 1" >
		<xsl:variable name="has_text" >
			<xsl:choose>
				<xsl:when test="normalize-space(text())='Unspecified'">unspecified</xsl:when>
				<xsl:when test="not(normalize-space(text())='')">text</xsl:when>				
				<xsl:otherwise>empty</xsl:otherwise>
			</xsl:choose>
			
		</xsl:variable>
		<div class="cmds-elem-prop value-{$has_text}" >
		<span class="label"><xsl:value-of select="name()" />
		<xsl:if test="@xml:lang" >(<xsl:value-of select="@xml:lang" />)</xsl:if>: </span>
		<span class="value"><xsl:value-of select="text()" /></span>
			<xsl:apply-templates select="*" />					
		</div>	
	</xsl:if>
</xsl:template>	


</xsl:stylesheet>