<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- 
<purpose>html-view for static xml-files</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-11-12" type="created" by="vr">based on xml2htmltable</change>	
	
</history>
-->

<xsl:param name="queryid" />


	
<!--<xsl:output method="html" encoding="UTF-8"/>-->

<xsl:template match="/">

<xsl:apply-templates select="//item[id=$queryid]" />

</xsl:template>

<xsl:template match="Queries/item" >
<VirtualCollection xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="VirtualCollection.xsd">
    <Type>intensional</Type>
    <Name><xsl:value-of select="name" /></Name>
    <Description>Collection published via CLARIN - MDService </Description>
    <CreationDate><xsl:value-of select="current-date()" /></CreationDate>
    <Creators>
        <Creator>
            <Person>MDService</Person>
            <Email>cmdi@clarin.eu</Email>
            <Organisation>CMDI </Organisation>
        </Creator>
    </Creators>
    <Purpose>sample</Purpose>
    <Reproducibility>untended</Reproducibility>
    <ReproducibilityNotice>Unmaintaned test collection.</ReproducibilityNotice>
    <!-- <Keywords>
        <Keyword>test</Keyword>
        <Keyword>unmaintained</Keyword>
    </Keywords> -->
    <GeneratedBy> 
        <Description>GeneratedBy CLARIN MDService</Description>
        <URI>urn:x-vcr:test-uri</URI>
        <Query profile="sru-cql">
        <xsl:text disable-output-escaping="yes">&lt;![CDATA[</xsl:text> 
		<xsl:choose>
        		<xsl:when test="squerystring = ''">
					<xsl:value-of select ="querystring"/>
				</xsl:when>	
				<xsl:when test="querystring = ''">
					<xsl:value-of select ="squerystring"/>
				</xsl:when>			
				<xsl:otherwise><xsl:value-of select ="squerystring"/> and (<xsl:value-of select ="querystring"/>)</xsl:otherwise>
		</xsl:choose>
        <xsl:text disable-output-escaping="yes">]]&gt;</xsl:text>
        </Query>
        <!-- 
        <Query profile="cmdservice"><xsl:copy-of select="querystring" />
				<xsl:copy-of select="squerystring" /><xsl:copy-of select="collections" />
		</Query>
         -->
    </GeneratedBy>
</VirtualCollection>
	
</xsl:template>

<xsl:template match="Bookmarksets/item" >
<VirtualCollection xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="VirtualCollection.xsd">
    <Type>extensional</Type>
    <Name><xsl:value-of select="name" /></Name>
    <Description>Collection published via CLARIN - MDService </Description>
    <CreationDate><xsl:value-of select="current-date()" /></CreationDate>
    <Creators>
        <Creator>
            <Person>MDService</Person>
            <Email>cmdi@clarin.eu</Email>
            <Organisation>CMDI </Organisation>
        </Creator>
    </Creators>
    <Purpose>sample</Purpose>
    <Reproducibility>untended</Reproducibility>
    <ReproducibilityNotice>Unmaintaned test collection.</ReproducibilityNotice>
    <!-- <Keywords>
        <Keyword>test</Keyword>
        <Keyword>unmaintained</Keyword>
    </Keywords> -->
    <Resources>
    	<xsl:for-each select="Bookmarks/item" >
	        <Resource>        
	            <ResourceType>Metadata</ResourceType>
	            <ResourceRef><xsl:value-of select="querystring" /></ResourceRef>
	        </Resource>
	    </xsl:for-each>
    </Resources>
</VirtualCollection>
	
</xsl:template>


</xsl:stylesheet>